/* ---------------------------------------------------------- 
%   (C)1993 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */

#ifndef _KLIC_ALLOC_H_
#define _KLIC_ALLOC_H_

/* heapbottom, heaplimit, real_heaplimit, interrupt_off */
#include <klic/struct.h>


/** Reverse allocation from "heaptop"
 * heapalloc: procedure
 *   s: maketype&
 *   words > 0: offset_t
 *   maketype: type cast or function returning q
 */

#define heapalloc(s, words, maketype) \
do{ \
  heapbottom -= (words); \
  (s) = maketype(heapbottom); \
\
  real_heaplimit -= (words); \
  if(heaplimit != 0) \
    heaplimit = (interrupt_off ? real_heaplimit : 0); \
}while(0)


/* runtime/intrpt.c */
extern q* klic_interrupt(q* allocp, struct goalrec* qp);

/* runtime/alloc.c */
extern char* malloc_check(unsigned long size);
extern char* realloc_check(char* original, unsigned long newsize);
extern void initalloc(void);
extern void register_gc_hook(q*(* routine)());
extern void register_after_gc_hook(q*(* routine)());

#endif /* _KLIC_ALLOC_H_ */
